From 0a5ced7b0b3b006a49f968a624ba359226461c4d Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Tor=20Arne=20Vestb=C3=B8?= <tor.arne.vestbo@qt.io>
Date: Fri, 30 Oct 2020 12:05:02 +0100
Subject: [PATCH 018/262] testlib: Let logger report whether it is logging to
 stdout
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Change-Id: I7df61b4fdc8c431a73c4b399e2f620923a7c7217
Reviewed-by: Simon Hausmann <hausmann@gmail.com>
(cherry picked from commit 81957e753ea0f875556490857fbff50688db42f1)
Reviewed-by: Tor Arne Vestbø <tor.arne.vestbo@qt.io>
---
 src/testlib/qabstracttestlogger.cpp |  5 +++++
 src/testlib/qabstracttestlogger_p.h |  2 ++
 src/testlib/qtestlog.cpp            | 11 ++++++-----
 3 files changed, 13 insertions(+), 5 deletions(-)

diff --git a/src/testlib/qabstracttestlogger.cpp b/src/testlib/qabstracttestlogger.cpp
index ff05dd88c7..c7a0784da7 100644
--- a/src/testlib/qabstracttestlogger.cpp
+++ b/src/testlib/qabstracttestlogger.cpp
@@ -90,6 +90,11 @@ QAbstractTestLogger::~QAbstractTestLogger()
     stream = nullptr;
 }
 
+bool QAbstractTestLogger::isLoggingToStdout() const
+{
+    return stream == stdout;
+}
+
 void QAbstractTestLogger::filterUnprintable(char *str) const
 {
     unsigned char *idx = reinterpret_cast<unsigned char *>(str);
diff --git a/src/testlib/qabstracttestlogger_p.h b/src/testlib/qabstracttestlogger_p.h
index e5a1404c16..079f5f87d5 100644
--- a/src/testlib/qabstracttestlogger_p.h
+++ b/src/testlib/qabstracttestlogger_p.h
@@ -106,6 +106,8 @@ public:
     virtual void addMessage(MessageTypes type, const QString &message,
                             const char *file = nullptr, int line = 0) = 0;
 
+    bool isLoggingToStdout() const;
+
     void outputString(const char *msg);
 
 protected:
diff --git a/src/testlib/qtestlog.cpp b/src/testlib/qtestlog.cpp
index be50176a08..58ba26d989 100644
--- a/src/testlib/qtestlog.cpp
+++ b/src/testlib/qtestlog.cpp
@@ -169,7 +169,6 @@ namespace QTest {
     static IgnoreResultList *ignoreResultList = nullptr;
 
     static QVector<QAbstractTestLogger*> loggers;
-    static bool loggerUsingStdout = false;
 
     static int verbosity = 0;
     static int maxWarnings = 2002;
@@ -431,7 +430,6 @@ void QTestLog::stopLogging()
         delete logger;
     }
     QTest::loggers.clear();
-    QTest::loggerUsingStdout = false;
     saveCoverageTool(QTestResult::currentAppName(), failCount() != 0, QTestLog::installedTestCoverage());
 }
 
@@ -439,8 +437,6 @@ void QTestLog::addLogger(LogMode mode, const char *filename)
 {
     if (filename && strcmp(filename, "-") == 0)
         filename = nullptr;
-    if (!filename)
-        QTest::loggerUsingStdout = true;
 
     QAbstractTestLogger *logger = nullptr;
     switch (mode) {
@@ -488,7 +484,12 @@ int QTestLog::loggerCount()
 
 bool QTestLog::loggerUsingStdout()
 {
-    return QTest::loggerUsingStdout;
+    FOREACH_TEST_LOGGER {
+        if (logger->isLoggingToStdout())
+            return true;
+    }
+
+    return false;
 }
 
 void QTestLog::warn(const char *msg, const char *file, int line)
-- 
2.33.0

#From d5ad9d483cb49644c28e4499b68260ec6e600243 Mon Sep 17 00:00:00 2001
#From: Assam Boudjelthia <assam.boudjelthia@qt.io>
#Date: Thu, 22 Oct 2020 18:11:21 +0300
#Subject: [PATCH 019/262] Android: disable Gradle caching by default
#
#If enabled by default, the cache size will grow quickly, especially
#if multiple different projects are managed every day. Keep the option
#commented, which can be enabled manually by the user.
#
#Change-Id: I6d4a67f4f1bb3e37b02de7ff4c534ec4d006f9a3
#Reviewed-by: Ville Voutilainen <ville.voutilainen@qt.io>
#Reviewed-by: Rami Potinkara <rami.potinkara@qt.io>
#(cherry picked from commit 90912b657edf27d40aa1a8ac8fbc3bae8d285e25)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#(cherry picked from commit 903a3b6493f1fe66b43eb8696b706d1943230e42)
#Reviewed-by: Andy Shaw <andy.shaw@qt.io>
#---
# src/3rdparty/gradle/gradle.properties | 6 ++++--
# 1 file changed, 4 insertions(+), 2 deletions(-)
#
#diff --git a/src/3rdparty/gradle/gradle.properties b/src/3rdparty/gradle/gradle.properties
#index 554f6aeba1..fded106b17 100644
#--- a/src/3rdparty/gradle/gradle.properties
#+++ b/src/3rdparty/gradle/gradle.properties
#@@ -5,5 +5,7 @@
# # The setting is particularly useful for tweaking memory settings.
# org.gradle.jvmargs=-Xmx2048m
# 
#-# Enable Gradle caching
#-org.gradle.caching=true
#+# Gradle caching allows reusing the build artifacts from a previous
#+# build with the same inputs. However, over time, the cache size will
#+# grow. Uncomment the following line to enable it.
#+#org.gradle.caching=true
#-- 
#2.33.0
#
#From 4766a7a62b11c932f483724294aca5b69d2c0194 Mon Sep 17 00:00:00 2001
#From: Assam Boudjelthia <assam.boudjelthia@qt.io>
#Date: Sat, 24 Oct 2020 16:31:37 +0300
#Subject: [PATCH 020/262] Android: replace stacktrace with debug message in
# search for setActivity
#
#Don't print stacktrace when setActivity is not found but only print a
#debug message, QtActivityDelegate will continue to look for setContext
#which might actually be a problem if not implemented.
#
#Fixes: QTBUG-86733
#Change-Id: Iaf7f347ae04605a1f616f24d25cac4938c1640a4
#Reviewed-by: Ville Voutilainen <ville.voutilainen@qt.io>
#Reviewed-by: Rami Potinkara <rami.potinkara@qt.io>
#(cherry picked from commit 950e628fd842f22ac741b18440fcc99213820587)
#Reviewed-by: Andy Shaw <andy.shaw@qt.io>
#(cherry picked from commit 46a12ef0c33893d1864f9a6c8b25b37a5976803b)
#---
# .../src/org/qtproject/qt5/android/QtActivityDelegate.java   | 6 ++++--
# 1 file changed, 4 insertions(+), 2 deletions(-)
#
#diff --git a/src/android/jar/src/org/qtproject/qt5/android/QtActivityDelegate.java b/src/android/jar/src/org/qtproject/qt5/android/QtActivityDelegate.java
#index b7689dc519..742505c39a 100644
#--- a/src/android/jar/src/org/qtproject/qt5/android/QtActivityDelegate.java
#+++ b/src/android/jar/src/org/qtproject/qt5/android/QtActivityDelegate.java
#@@ -95,6 +95,7 @@ import java.lang.reflect.Constructor;
# import java.lang.reflect.Method;
# import java.util.ArrayList;
# import java.util.HashMap;
#+import java.util.Objects;
# 
# import org.qtproject.qt5.android.accessibility.QtAccessibilityDelegate;
# 
#@@ -575,7 +576,7 @@ public class QtActivityDelegate
#         QtNative.setActivity(m_activity, this);
#         QtNative.setClassLoader(classLoader);
#         if (loaderParams.containsKey(STATIC_INIT_CLASSES_KEY)) {
#-            for (String className: loaderParams.getStringArray(STATIC_INIT_CLASSES_KEY)) {
#+            for (String className: Objects.requireNonNull(loaderParams.getStringArray(STATIC_INIT_CLASSES_KEY))) {
#                 if (className.length() == 0)
#                     continue;
# 
#@@ -586,9 +587,10 @@ public class QtActivityDelegate
#                       Method m = initClass.getMethod("setActivity", Activity.class, Object.class);
#                       m.invoke(staticInitDataObject, m_activity, this);
#                   } catch (Exception e) {
#-                      e.printStackTrace();
#+                      Log.d(QtNative.QtTAG, "Class " + className + " does not implement setActivity method");
#                   }
# 
#+                  // For modules that don't need/have setActivity
#                   try {
#                       Method m = initClass.getMethod("setContext", Context.class);
#                       m.invoke(staticInitDataObject, (Context)m_activity);
#-- 
#2.33.0
#
